#!/usr/bin/perl -i
#
#             , 
#      

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#        Retract on layer change  
#        ,      Gcode
#  Only retract when crossing perimeters   
#       Custom G-code,   After layer change G-code 
#  Gcode:    ;G92 E0
#        
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

# G1 Z ,    ,      
#  G1 Z, 
#G1 E4.00000  -4    ,   3   
#   G1 E4.0000  G92 E0,    
# G92 E0 -   
# G92 E0 -    

use strict;
use warnings;

my $HANDLE=@ARGV[0]; 					#    13 ,    ARGV[0], ..    print(length(@ARGV[0]));
										#  print($HANDLE);          @ARGV[0]

my $LayerNumWhenScriptStart=6;			#        GCode
my $SearchValue = "G92 E0";				#    ,      
my $AddRetract=0.7;						# ,           ,    . 
										#      1.1    ,  0.75   ,    0.9 
										#       0.7
my $E_value= 0.00000;
my $AfterE='';							#         E

my $FilePos=0;							#      
my $FilePosNext=0;						#      
my $CharPos=0;							#   E   
my $String='';							#  

my $G1Z =0;								# 
my $RetractCount=0;
my $AfterSkirt=0;

open FILE, "+< $HANDLE";
print("File opened \n");

$LayerNumWhenScriptStart++;				#     "G1 Z"

while (<FILE>) 
{ #       
	if (/G1 Z/)
		{
		$G1Z++;							#    
		$RetractCount=0;
		$AddPlastic=0;
		}
	if(/$SearchValue/) 					#     "G92 E0"
		{
		$RetractCount++;
		}
		if($G1Z>$LayerNumWhenScriptStart && $RetractCount==2) 	#    ,   
			{
			if(/G1/ && /E/ )	#     ,    
				{
				$FilePos=tell(FILE);									#      
				$FilePosNext= $FilePos;
				$String=$_;												#   
				$CharPos=index($String, 'E')+1;							#        E
				$E_value=substr($String,$CharPos,length($String));		#   E  
				$AfterE= $E_value;
				$E_value=$E_value+$AddRetract;												#       E   
				$AfterE= substr($AfterE,length($E_value),length($AfterE)-length($E_value)); #     E
				substr($E_value,length($E_value),length($AfterE),$AfterE);					#    E    ,    
				substr($String,$CharPos,length($String)-1,$E_value);						#      E 
				substr($String,length($String)-1,2," ");		#     ,       
				$FilePos= $FilePos-length($String)-1;			
				seek(FILE,$FilePos,0);							#     
				syswrite(FILE, $String, length($String) );		#   
				seek(FILE,$FilePosNext,0);						#       ,      ,     
																#    
				}
			}
}